//+------------------------------------------------------------------+
//|                                                        HH_LL.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 3

#property indicator_color1 Red
#property indicator_color2 Aqua
#property indicator_color3 Yellow

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1

#property indicator_style1 0
#property indicator_style2 0
#property indicator_style3 0



int MaPeriod=1;
int MaMethod=0;
int MaPrice=0;
//close = 0
//high = 2
//low= 3

extern int HHLLPeriod=20;


 int CountBars=1500;


double MA[];
double HH_MA[];
double LL_MA[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(0,MA);
   SetIndexBuffer(1,HH_MA);
   SetIndexBuffer(2,LL_MA);
   SetIndexLabel(1,"Moving Maximum of Close price");
   SetIndexLabel(2,"Moving Minimum of Close price");
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if(Bars<=100) return(0);
   
   if (CountBars>Bars-1) CountBars=Bars-1;
   
   int i=CountBars-MathMax(HHLLPeriod,MaPeriod);

   
   while(i>=0)
     {
     
     MA[i]=iMA(NULL,0,MaPeriod,0,MaMethod,MaPrice,i);
     
      double max=-1000000;
      double min=1000000;
      int k = i + HHLLPeriod-1;
      while(k>=i)
        {
         if(max<MA[k]) max=MA[k];
         if(min>MA[k]) min=MA[k];
         k--;
        }
/* 
   int Highest( string symbol, int timeframe, int type, int count=WHOLE_ARRAY, int start=0) 
   val=High[Highest(NULL,0,MODE_HIGH,20,4)];
*/
     HH_MA[i]=max;
     LL_MA[i]=min;

     i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+